VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "howto_net_list_primes"
   ClientHeight    =   4410
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4125
   LinkTopic       =   "Form1"
   ScaleHeight     =   4410
   ScaleWidth      =   4125
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtActualPrimes 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   1200
      TabIndex        =   7
      Top             =   1200
      Width           =   1335
   End
   Begin VB.TextBox txtEstPrimes 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   1200
      TabIndex        =   5
      Top             =   840
      Width           =   1335
   End
   Begin VB.ListBox lstPrimes 
      Height          =   2595
      Left            =   120
      TabIndex        =   3
      Top             =   1680
      Width           =   3855
   End
   Begin VB.TextBox txtMaxNumber 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   1200
      TabIndex        =   2
      Text            =   "10000"
      Top             =   240
      Width           =   1335
   End
   Begin VB.CommandButton cmdListPrimes 
      Caption         =   "List Primes"
      Default         =   -1  'True
      Height          =   495
      Left            =   2760
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "Actual Primes:"
      Height          =   195
      Left            =   120
      TabIndex        =   6
      Top             =   1200
      Width           =   1005
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Est. Primes:"
      Height          =   195
      Left            =   120
      TabIndex        =   4
      Top             =   840
      Width           =   825
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Max Number:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   945
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' List primes.
Private Sub cmdListPrimes_Click()
Dim max As Integer
Dim is_prime() As Boolean
Dim i As Integer
Dim j As Integer
Dim max_i As Integer
Dim max_j As Integer
Dim est As Double

        ' Make an array big enough.
        max = Val(txtMaxNumber.Text)
        ReDim is_prime(0 To max)

        ' Assume all of the odd numbers are prime.
        ' Ignore the even numbers.
        For i = 3 To max Step 2
            is_prime(i) = True
        Next i

        ' Use Euler's Sieve.
        ' See http://en.wikipedia.org/wiki/Sieve_of_Eratosthenes.
        max_i = Sqr(max) + 1
        For i = 3 To max_i
            ' Only use i if it is prime.
            If (is_prime(i)) Then
                ' Decide where we need to stop.
                max_j = max \ i
                If (max_j Mod 2 = 0) Then max_j = max_j - 1 ' Make it odd.

                ' "Cross out" multiples of i starting
                ' with i * max_j and ending with i * i.
                For j = max_j To i Step -2
                    ' Only use j if it is prime.
                    If (is_prime(j)) Then
                        ' "Cross out" i * j.
                        is_prime(i * j) = False
                    End If
                Next j
            End If
        Next i

        ' Display the results.
        lstPrimes.Clear
        lstPrimes.AddItem "2"
        For i = 3 To max Step 2
            If (is_prime(i)) Then lstPrimes.AddItem i
        Next i

        ' Display the actual number of primes.
        txtActualPrimes.Text = Format$(lstPrimes.ListCount)

        ' Display a Legendre estimate ?(n) = n/(log(n) - 1.08366).
        ' See http://mathworld.wolfram.com/PrimeCountingFunction.html.
        est = max / (Log(max) - 1.08366)
        txtEstPrimes.Text = Format$(est, "0")
End Sub
